//AUTHOR: Andrew Kuklin
//REQUESTER: Aibek Musaev 
//DATE: 27 October, 2002
//PURPOSE: Interview problem. 
//The program prints numbers from 1 to 15 
//to standard output (descending and ascending).
//EXTRA CONDITIONS: 
//No loops and conditional statements are allowed
//COMMENTS:
//Loop statement was replaced by recursion,
//Conditional statement was replaced by side-affect
//exception throwing (division-by-zero).
//Program can be improved by allowing the user to enter
//upper and lower bounds and ways of printing 
//(ascending and/or descending).
//PLATFORM: Win32
//ENVIRONMENT: Visual C++ 6.0


#include "stdafx.h"
#include <iostream> //For cin, cout objects

using namespace std; //Use standard templates' namespace

//Recursive function, 
//prints the line of numbers on each iteration, 
//theIteration is increased in every call
int printALine(int theLower, int theUpper, int theIteration);


//Global variables. Could be moved to main, but no need
//to ensure encapsulation for a program of this size.
//Redefine these figures for your case
//Be careful, no testing for valid 
//figures (lowerBound<=upperBound) is made
int lowerBound = 1;
int upperBound = 15;

//Main
int main(int argc, char* argv[]){			
	//Show must go on
	//Iteration on first turn = 0
	printALine(lowerBound, upperBound, 0);
	
	return 0;
}


//See declaration for comments
int printALine(int theLower, int theUpper, int theIteration) {
	//Output the descending and ascending sequence
	cout<<(theUpper - theIteration)<<"\t";
	cout<<(theLower + theIteration)<<"\n";

	try{
		//Check whether theUpper (the upper bound of the next step)
		//has reached lowerBound (initial). Zero-division exception
		//will be thrown
		float temp = 1/(theUpper - lowerBound - theIteration);
		
		//Next iteration (theIteration is increased)
		printALine(theLower, theUpper, ++theIteration);
	}
	catch(...){
		//lowerBound reached! Stop.
		//In Java catch(...) means 'catch exception of all types'
		//Probably in C++ too. At least this works.
		return 0;
	}
	return 0; //Just for a case. For compilation without warnings
}